using System.Diagnostics;
using System.Data;
using System.Collections;
using Microsoft.VisualBasic;
using System.Collections.Generic;
using System;

namespace Optim_RandomSearch1
{
	public delegate double MyFxDelegate(int nNumVars, ref double[] fX, ref double[] fParam);
	public delegate string SayFxDelegate();
	
	public class CRandomSearch1
	{
		public double CalcOptim(int nNumVars, ref double[] fX, ref double[] fParam, ref double[] fXLo, ref double[] fXHi, int nMaxIter, double EpsFx, ref int nIter, MyFxDelegate MyFx)
		{
			
			double F;
			double fBestF;
			double[] fBestX;
			double fLastBestF;
			int i;
            Random objRand = new Random(3);
			
			fBestX = new double[nNumVars];
			
			for (i = 0; i < nNumVars; i++)
			{
				fBestX[i] = fX[i];
			}
			// calculate and display function value at initial point
            fBestF = MyFx(nNumVars, ref fBestX, ref fParam);
			if (fBestF > 0)
			{
				fLastBestF = fBestF + 100;
			}
			else
			{
				fLastBestF = 100 - fBestF;
			}
			
			nIter = 0;
			do
			{
				nIter++;
				if (nIter > nMaxIter)
				{
					break;
				}
				// VBMath.Randomize(DateAndTime.Timer);
				for (i = 0; i < nNumVars; i++)
				{
                    fX[i] = fXLo[i] + objRand.NextDouble() * (fXHi[i] - fXLo[i]);
				}
                F = MyFx(nNumVars, ref fX, ref fParam);
				if (F < fBestF)
				{
					for (i = 0; i < nNumVars; i++)
					{
						fBestX[i] = fX[i];
					}
					fBestF = F;
					
					// test function value convergence
					if (Math.Abs(fBestF - fLastBestF) < EpsFx)
					{
						break;
					}
					fLastBestF = fBestF;
				}
			} while (true);
			
			return fBestF;
			
		}
	}
	
}
